blob: a57c4d68d332cabd8f4817d033da851d95defd9b [file] [log] [blame]
Rob Landley16890752005-09-02 00:41:53 +00001# Simple test harness infrastructurei for BusyBox
2#
3# Copyright 2005 by Rob Landley
4#
5# License is GPLv2, see LICENSE in the busybox tarball for full license text.
6
Denis Vlasenko687a26f2008-05-02 21:46:30 +00007# This file defines two functions, "testing" and "optional"
8# and a couple more...
Rob Landley48c61572005-11-07 08:50:53 +00009
Rob Landley48c61572005-11-07 08:50:53 +000010# The following environment variables may be set to enable optional behavior
11# in "testing":
12# VERBOSE - Print the diff -u of each failed test case.
13# DEBUG - Enable command tracing.
Denis Vlasenko687a26f2008-05-02 21:46:30 +000014# SKIP - do not perform this test (this is set by "optional")
Rob Landley48c61572005-11-07 08:50:53 +000015#
16# The "testing" function takes five arguments:
Denis Vlasenko687a26f2008-05-02 21:46:30 +000017# $1) Test description
18# $2) Command(s) to run. May have pipes, redirects, etc
19# $3) Expected result on stdout
20# $4) Data to be written to file "input"
21# $5) Data to be written to stdin
Rob Landley16890752005-09-02 00:41:53 +000022#
Denis Vlasenko687a26f2008-05-02 21:46:30 +000023# The exit value of testing is the exit value of $2 it ran.
Rob Landley16890752005-09-02 00:41:53 +000024#
25# The environment variable "FAILCOUNT" contains a cumulative total of the
Rob Landley48c61572005-11-07 08:50:53 +000026# number of failed tests.
Rob Landley16890752005-09-02 00:41:53 +000027
Rob Landley48c61572005-11-07 08:50:53 +000028# The "optional" function is used to skip certain tests, ala:
Denis Vlasenko687a26f2008-05-02 21:46:30 +000029# optional CONFIG_FEATURE_THINGY
Rob Landley48c61572005-11-07 08:50:53 +000030#
31# The "optional" function checks the environment variable "OPTIONFLAGS",
32# which is either empty (in which case it always clears SKIP) or
33# else contains a colon-separated list of features (in which case the function
34# clears SKIP if the flag was found, or sets it to 1 if the flag was not found).
Rob Landley16890752005-09-02 00:41:53 +000035
36export FAILCOUNT=0
Rob Landley48c61572005-11-07 08:50:53 +000037export SKIP=
Rob Landley16890752005-09-02 00:41:53 +000038
Bernhard Reutner-Fischerb47a74f2005-09-23 15:44:46 +000039# Helper functions
40
Rob Landleycd82c3c2006-06-15 20:07:57 +000041optional()
Bernhard Reutner-Fischerb47a74f2005-09-23 15:44:46 +000042{
Denis Vlasenko687a26f2008-05-02 21:46:30 +000043 option=`echo ":$OPTIONFLAGS:" | grep ":$1:"`
Rob Landley48c61572005-11-07 08:50:53 +000044 # Not set?
Rob Landley006fa2d2006-02-16 09:00:57 +000045 if [ -z "$1" ] || [ -z "$OPTIONFLAGS" ] || [ ${#option} -ne 0 ]
Rob Landley48c61572005-11-07 08:50:53 +000046 then
Denis Vlasenko687a26f2008-05-02 21:46:30 +000047 SKIP=
Rob Landley48c61572005-11-07 08:50:53 +000048 return
49 fi
50 SKIP=1
Bernhard Reutner-Fischerb47a74f2005-09-23 15:44:46 +000051}
52
Rob Landley16890752005-09-02 00:41:53 +000053# The testing function
54
Denis Vlasenkocd0df462007-06-05 22:29:14 +000055testing()
Rob Landley16890752005-09-02 00:41:53 +000056{
Rob Landley4bb1b042006-03-16 15:20:45 +000057 NAME="$1"
Denis Vlasenko81e97a12008-05-15 22:43:48 +000058 [ -n "$1" ] || NAME="$2"
Rob Landley4bb1b042006-03-16 15:20:45 +000059
Rob Landley16890752005-09-02 00:41:53 +000060 if [ $# -ne 5 ]
61 then
Denis Vlasenko4e1e7202007-11-26 05:38:20 +000062 echo "Test $NAME has wrong number of arguments (must be 5) ($# $*)" >&2
Denis Vlasenko81e97a12008-05-15 22:43:48 +000063 exit 1
Rob Landley16890752005-09-02 00:41:53 +000064 fi
65
Denis Vlasenko81e97a12008-05-15 22:43:48 +000066 [ -z "$DEBUG" ] || set -x
Mike Frysinger3f91d7a2005-09-24 00:52:58 +000067
Rob Landley48c61572005-11-07 08:50:53 +000068 if [ -n "$SKIP" ]
Bernhard Reutner-Fischerb47a74f2005-09-23 15:44:46 +000069 then
Rob Landley4bb1b042006-03-16 15:20:45 +000070 echo "SKIPPED: $NAME"
Rob Landley48c61572005-11-07 08:50:53 +000071 return 0
Bernhard Reutner-Fischerb47a74f2005-09-23 15:44:46 +000072 fi
73
Denis Vlasenko687a26f2008-05-02 21:46:30 +000074 $ECHO -ne "$3" > expected
75 $ECHO -ne "$4" > input
Rob Landley67d5b8b2006-05-02 21:39:04 +000076 [ -z "$VERBOSE" ] || echo "echo '$5' | $2"
Denis Vlasenko687a26f2008-05-02 21:46:30 +000077 $ECHO -ne "$5" | eval "$2" > actual
Rob Landley16890752005-09-02 00:41:53 +000078 RETVAL=$?
79
Denis Vlasenko81e97a12008-05-15 22:43:48 +000080 if cmp expected actual >/dev/null 2>/dev/null
Rob Landley16890752005-09-02 00:41:53 +000081 then
Denis Vlasenko81e97a12008-05-15 22:43:48 +000082 echo "PASS: $NAME"
83 else
Denis Vlasenko2dea01c2008-05-02 09:39:09 +000084 FAILCOUNT=$(($FAILCOUNT + 1))
Rob Landley4bb1b042006-03-16 15:20:45 +000085 echo "FAIL: $NAME"
Denis Vlasenko81e97a12008-05-15 22:43:48 +000086 [ -z "$VERBOSE" ] || diff -u expected actual
Rob Landley16890752005-09-02 00:41:53 +000087 fi
88 rm -f input expected actual
89
Denis Vlasenko81e97a12008-05-15 22:43:48 +000090 [ -z "$DEBUG" ] || set +x
Mike Frysinger3f91d7a2005-09-24 00:52:58 +000091
Rob Landley16890752005-09-02 00:41:53 +000092 return $RETVAL
93}
Rob Landley3a324752006-03-09 22:04:33 +000094
95# Recursively grab an executable and all the libraries needed to run it.
96# Source paths beginning with / will be copied into destpath, otherwise
97# the file is assumed to already be there and only its library dependencies
98# are copied.
99
Denis Vlasenkocd0df462007-06-05 22:29:14 +0000100mkchroot()
Rob Landley3a324752006-03-09 22:04:33 +0000101{
102 [ $# -lt 2 ] && return
103
Denis Vlasenko687a26f2008-05-02 21:46:30 +0000104 $ECHO -n .
Rob Landley4bb1b042006-03-16 15:20:45 +0000105
Rob Landley3a324752006-03-09 22:04:33 +0000106 dest=$1
107 shift
108 for i in "$@"
109 do
Denis Vlasenko2dea01c2008-05-02 09:39:09 +0000110 #bashism: [ "${i:0:1}" == "/" ] || i=$(which $i)
111 i=$(which $i) # no-op for /bin/prog
Rob Landley6bc10632006-03-18 03:01:57 +0000112 [ -f "$dest/$i" ] && continue
113 if [ -e "$i" ]
Rob Landley3a324752006-03-09 22:04:33 +0000114 then
Rob Landley3a324752006-03-09 22:04:33 +0000115 d=`echo "$i" | grep -o '.*/'` &&
116 mkdir -p "$dest/$d" &&
117 cat "$i" > "$dest/$i" &&
118 chmod +x "$dest/$i"
Rob Landley6bc10632006-03-18 03:01:57 +0000119 else
120 echo "Not found: $i"
Rob Landley3a324752006-03-09 22:04:33 +0000121 fi
122 mkchroot "$dest" $(ldd "$i" | egrep -o '/.* ')
123 done
124}
Rob Landley4bb1b042006-03-16 15:20:45 +0000125
126# Set up a chroot environment and run commands within it.
127# Needed commands listed on command line
128# Script fed to stdin.
129
Denis Vlasenkocd0df462007-06-05 22:29:14 +0000130dochroot()
Rob Landley4bb1b042006-03-16 15:20:45 +0000131{
132 mkdir tmpdir4chroot
133 mount -t ramfs tmpdir4chroot tmpdir4chroot
134 mkdir -p tmpdir4chroot/{etc,sys,proc,tmp,dev}
135 cp -L testing.sh tmpdir4chroot
136
137 # Copy utilities from command line arguments
138
Denis Vlasenko687a26f2008-05-02 21:46:30 +0000139 $ECHO -n "Setup chroot"
Rob Landley4bb1b042006-03-16 15:20:45 +0000140 mkchroot tmpdir4chroot $*
141 echo
142
143 mknod tmpdir4chroot/dev/tty c 5 0
144 mknod tmpdir4chroot/dev/null c 1 3
145 mknod tmpdir4chroot/dev/zero c 1 5
146
147 # Copy script from stdin
148
149 cat > tmpdir4chroot/test.sh
150 chmod +x tmpdir4chroot/test.sh
151 chroot tmpdir4chroot /test.sh
152 umount -l tmpdir4chroot
153 rmdir tmpdir4chroot
154}